import javax.media.opengl.GL;
import javax.media.opengl.GLEventListener;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.glu.GLU;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

public class Renderizador implements GLEventListener, KeyListener {
   private static final GLU glu = new GLU();
   
   public boolean desenhaPontosControle = true;
   public boolean desenhaCopo           = true;
   public boolean desenhaPontosCurva    = true;
   public boolean desenhaVetorU         = false;
   public boolean desenhaVetorV         = false;
   public boolean desenhaVetorN         = false;

   public int posCurva = 13;
   public int posPonto = 15;
   
   public double MaiorGauss = 0.0f;
   public double MenorGauss = 0.0f;
   public double MaiorMed   = 0.0f;
   public double MenorMed   = 0.0f;
   
   public String curvatura = "m";
   //curvaturas n = normal
   //           g = gaussiana
   //           m = mdia
   
   public double ind0, ind1, ind2, ind3, ind4, ind5;
   public double E, F, G, en, fn, gn;

   public void display(GLAutoDrawable gLDrawable) {

       final GL gl = gLDrawable.getGL();

       gl.glClear(GL.GL_COLOR_BUFFER_BIT);
       gl.glClear(GL.GL_DEPTH_BUFFER_BIT);
       gl.glLoadIdentity();

       gl.glTranslatef(0.0f, -2.0f, -7.0f);

       Ponto  pontosControle[]        = new Ponto[4];
       Ponto  pontosCurva[]           = new Ponto[41];
       double curvaturaGaussiana[][]  = new double[36][41];
       double curvaturaMedia[][]      = new double[36][41];

       Ponto pontosCopo[][]          = new Ponto[36][41];
       Ponto pontosUCopo[][]         = new Ponto[36][41];
       Ponto pontosVCopo[][]         = new Ponto[36][41];
       Ponto pontosNCopo[][]         = new Ponto[36][41];
            
       //Meus pontos de controle
       pontosControle[0] = new Ponto(0, 0, 0);
       pontosControle[1] = new Ponto(4, 0, 0);
       pontosControle[2] = new Ponto(1, 2, 0);
       pontosControle[3] = new Ponto(2, 4, 0);
       
       double t; 
       double k = .025; //Os passos da minha curva
       
       double x, y, z;

       int ptoCurva = 0;       
       for(t=0;t<=1+k;t+=k){

		 x = 11*(t*t*t)-21*(t*t)+12*t;
		 y = -2*(t*t*t)+6*(t*t);
		 z = 0;
   
         //desenha os pontos da curva
		 if (desenhaPontosCurva) {
	         gl.glColor3f(0.0f, 1.0f, 0.0f);
	         gl.glBegin(GL.GL_POINTS);
	            gl.glVertex3f((float)x, (float)y, (float)z);
	         gl.glEnd();
		 }
         
         //Armazenar todos os pontos da curva de Bzier
         pontosCurva[ptoCurva]  = new Ponto(x, y, z);

         ptoCurva++;
       }

       //crio os pontos do copo por rotao em Y
       for (int wj=0; wj<36;wj++){       
           for (int wk=0; wk<41;wk++){        	   
           	   double sinTeta = Math.sin(wj*10*3.1415 / 180);
               double cosTeta = Math.cos(wj*10*3.1415 / 180);

               pontosCopo[wj][wk] = new Ponto(0, 0, 0);
               pontosCopo[wj][wk].x = (cosTeta * pontosCurva[wk].x);
               pontosCopo[wj][wk].y = (pontosCurva[wk].y); //Constante por causa da rotao
               pontosCopo[wj][wk].z = (sinTeta * pontosCurva[wk].x);
               
               //Vetores tangentes - Ru
               t = wk*k;
      		   x = (33*(t*t)-42*t+12)*cosTeta;
    		   y = -6*(t*t)+12*t;
    		   z = (33*(t*t)-42*t+12)*sinTeta;   		   

    		   ind0 = x;
       	       ind1 = y;
       	       ind2 = z;
    		   
               double L = Math.sqrt(x*x + y*y + z*z);
               x = pontosCopo[wj][wk].x + x/L;
               y = pontosCopo[wj][wk].y + y/L;
               z = pontosCopo[wj][wk].z + z/L;
               pontosUCopo[wj][wk] = new Ponto(x, y, z);
               
               //Vetores tangentes - Rv
               x = (11*(t*t*t)-21*(t*t)+12*t)*sinTeta;
    		   y = 0;
    		   z = -(11*(t*t*t)-21*(t*t)+12*t)*cosTeta;
    		   
    		   ind3 = x;
       	       ind4 = y;
       	       ind5 = z;

               L = Math.sqrt(x*x + y*y + z*z);
               x = pontosCopo[wj][wk].x + x/L;
               y = pontosCopo[wj][wk].y + y/L;
               z = pontosCopo[wj][wk].z + z/L;
               pontosVCopo[wj][wk] = new Ponto(x, y, z);

               //Vetores normais - N
               x = (((pontosUCopo[wj][wk].y - pontosCopo[wj][wk].y) * (pontosVCopo[wj][wk].z - pontosCopo[wj][wk].z)) - 
               	    ((pontosUCopo[wj][wk].z - pontosCopo[wj][wk].z) * (pontosVCopo[wj][wk].y - pontosCopo[wj][wk].y)));               
               y = (((pontosUCopo[wj][wk].z - pontosCopo[wj][wk].z) * (pontosVCopo[wj][wk].x - pontosCopo[wj][wk].x)) - 
               	    ((pontosUCopo[wj][wk].x - pontosCopo[wj][wk].x) * (pontosVCopo[wj][wk].z - pontosCopo[wj][wk].z)));
               z = (((pontosUCopo[wj][wk].x - pontosCopo[wj][wk].x) * (pontosVCopo[wj][wk].y - pontosCopo[wj][wk].y)) - 
               	    ((pontosUCopo[wj][wk].y - pontosCopo[wj][wk].y) * (pontosVCopo[wj][wk].x - pontosCopo[wj][wk].x)));               
               L = Math.sqrt(x*x + y*y + z*z);
               x = pontosCopo[wj][wk].x - x/L;
               y = pontosCopo[wj][wk].y - y/L;
               z = pontosCopo[wj][wk].z - z/L;
               pontosNCopo[wj][wk] = new Ponto(x, y, z);
               
               //Curvaturas               
               E = (ind0 * ind0) + (ind1 * ind1) + (ind2 * ind2);
               F = (ind0 * ind3) + (ind1 * ind4) + (ind2 * ind5);
               G = (ind3 * ind3) + (ind4 * ind4) + (ind5 * ind5);

               en = (((66.0f * t -42.0f) * cosTeta) * x) + 
       			    ((-12.0f * t + 12.0f)           * y) + 
       			    (((66.0f * t - 42.0f)*sinTeta)  * z);

               fn = ((-(33.0f * (t*t) - 42.0f * t + 12.0f)*sinTeta) * x) + 
       			    (((33.0f * (t*t) - 42.0f * t + 12.0f)*cosTeta)  * z);

               gn = ((-(11.0f * (t*t*t) - 21.0f * (t*t) + 12.0f * t) * cosTeta) * x) + 
       			    ((-(11.0f * (t*t*t) - 21.0f * (t*t) + 12.0f * t) * sinTeta) * z);
               
               //Curvatura Gaussiana
               double CurvGauss = (en * gn - fn * fn)/((E * G - F * F));
               curvaturaGaussiana[wj][wk] = CurvGauss;               
               if(CurvGauss > MaiorGauss){MaiorGauss = CurvGauss;}
               if(CurvGauss < MenorGauss){MenorGauss = CurvGauss;}
               
               //Curvatura Mdia
               double CurvMed = (E * gn + G * en - 2*F*fn)/2*((E * G - F * F));
               curvaturaMedia[wj][wk] = CurvMed;
               if(CurvMed > MaiorMed){MaiorMed = CurvMed;}
               if(CurvMed < MenorMed){MenorMed = CurvMed;}
           }
       }

       // desenha o copo
       if (desenhaCopo) {
	       for (int wj=1; wj<36;wj++){	  
	    	   
	     	   gl.glBegin(GL.GL_LINES);
	     	   
	           for (int wk=1; wk<41;wk++){
	        	   
	        	  if (curvatura=="n") {
	        		  
	 	    	     gl.glColor3f(0.0f, 0.0f, 1.0f);
	 	    	     
	 	    	  } else if (curvatura=="g") {
	 	    		  
	 	    		 float interval_gauss = (float)(MaiorGauss - MenorGauss);
	 	             float valor_gauss = (float)curvaturaGaussiana[wj][wk];
	 	             float cor = (float)(valor_gauss - MenorGauss)/interval_gauss;	 	                
	                
	                 if (cor < 0.5){
	                    gl.glColor3f(1.0f - cor*2, cor*2, 0.0f);
	                 }else{
	                    gl.glColor3f(0.0f, 1.0f - (cor-0.5f)*2, (cor-0.5f)*2);
	                 }
	 	             
	 	             
  	    	      } else if (curvatura=="m") {
  	    	    	  
	 	    		 float interval_med = (float)(MaiorMed - MenorMed);
	 	             float valor_med = (float)curvaturaMedia[wj][wk];
	 	             float cor = (float)(valor_med - MenorMed)/interval_med;	 	                
	 	             
	 	             if (cor < 0.5){
	                    gl.glColor3f(1.0f - cor*2, cor*2, 0.0f);
	                 }else{
	                    gl.glColor3f(0.0f, 1.0f - (cor-0.5f)*2, (cor-0.5f)*2);
	                 }
	 	             
  	    	      }

	        	  gl.glVertex3f((float)pontosCopo[wj][wk-1].x, 
	 		                    (float)pontosCopo[wj][wk-1].y, 
	 		                    (float)pontosCopo[wj][wk-1].z);
		          gl.glVertex3f((float)pontosCopo[wj][wk].x, 
	      		                (float)pontosCopo[wj][wk].y, 
	      		                (float)pontosCopo[wj][wk].z);
		          
		          gl.glVertex3f((float)pontosCopo[wj-1][wk].x, 
		                    	(float)pontosCopo[wj-1][wk].y, 
		                    	(float)pontosCopo[wj-1][wk].z);
	              gl.glVertex3f((float)pontosCopo[wj][wk].x, 
			                	(float)pontosCopo[wj][wk].y, 
			                	(float)pontosCopo[wj][wk].z);
	           }
	           
	           gl.glEnd();
	       }

	       //ltima linha que nunca  desenhada
	       gl.glBegin(GL.GL_LINES);
     	   
           for (int wk=1; wk<41;wk++){
        	   
        	  if (curvatura=="n") {
    		  
 	    	     gl.glColor3f(0.0f, 0.0f, 1.0f);
 	    	     
 	    	  } else if (curvatura=="g") {
 	    		  
 	    		 float interval_gauss = (float)(MaiorGauss - MenorGauss);
 	             float valor_gauss = (float)curvaturaGaussiana[0][wk];
 	             float cor = (float)(valor_gauss - MenorGauss)/interval_gauss;	 	                
 	             
 	             if (cor < 0.5){
	                gl.glColor3f(1.0f - cor*2, cor*2, 0.0f);
	             }else{
	                gl.glColor3f(0.0f, 1.0f - (cor-0.5f)*2, (cor-0.5f)*2);
	             }
 	             
    	      } else if (curvatura=="m") {
    	    	  
 	    		 float interval_med = (float)(MaiorMed - MenorMed);
 	             float valor_med = (float)curvaturaMedia[0][wk];
 	             float cor = (float)(valor_med - MenorMed)/interval_med;
 	             
 	             if (cor < 0.5){
 	                gl.glColor3f(1.0f - cor*2, cor*2, 0.0f);
 	             }else{
 	                gl.glColor3f(0.0f, 1.0f - (cor-0.5f)*2, (cor-0.5f)*2);
 	             }
 	             
    	      }        	   
        	   
        	  gl.glVertex3f((float)pontosCopo[0][wk-1].x, 
                   	        (float)pontosCopo[0][wk-1].y, 
                   	        (float)pontosCopo[0][wk-1].z);
              gl.glVertex3f((float)pontosCopo[0][wk].x, 
	                  	    (float)pontosCopo[0][wk].y, 
	                 	    (float)pontosCopo[0][wk].z);
              
	          gl.glVertex3f((float)pontosCopo[35][wk].x, 
	                    	(float)pontosCopo[35][wk].y, 
	                    	(float)pontosCopo[35][wk].z);
              gl.glVertex3f((float)pontosCopo[0][wk].x, 
		                	(float)pontosCopo[0][wk].y, 
		                	(float)pontosCopo[0][wk].z);
           }
           
           gl.glEnd();

       }
       
       // desenha os vetores tangentes  superfcie e as normais       
       for (int wj=0; wj<36;wj++){

    	   gl.glColor3f(0.0f, 0.0f, 1.0f);
     	   gl.glBegin(GL.GL_LINES);

           for (int wk=0; wk<41;wk++){
              //Vetores tangentes - Ru
        	   if (desenhaVetorU) {
	              gl.glColor3f(1.0f, 1.0f, 0.0f);
		          gl.glVertex3f((float)pontosCopo[wj][wk].x,
	                  	        (float)pontosCopo[wj][wk].y,
	                        	(float)pontosCopo[wj][wk].z);
	              gl.glVertex3f((float)pontosUCopo[wj][wk].x, 
		                	    (float)pontosUCopo[wj][wk].y, 
		                	    (float)pontosUCopo[wj][wk].z);
        	   }
              
              //Vetores tangentes - Rv
        	   if (desenhaVetorV) {
	              gl.glColor3f(0.0f, 1.0f, 1.0f);
		          gl.glVertex3f((float)pontosCopo[wj][wk].x, 
	                  	        (float)pontosCopo[wj][wk].y, 
	                        	(float)pontosCopo[wj][wk].z);
	              gl.glVertex3f((float)pontosVCopo[wj][wk].x, 
		                	    (float)pontosVCopo[wj][wk].y, 
		                	    (float)pontosVCopo[wj][wk].z);
        	   }

              //Vetores normais - N
        	   if (desenhaVetorN) {
	              gl.glColor3f(1.0f, 1.0f, 1.0f);
		          gl.glVertex3f((float)pontosCopo[wj][wk].x, 
	                  	        (float)pontosCopo[wj][wk].y, 
	                        	(float)pontosCopo[wj][wk].z);
	              gl.glVertex3f((float)pontosNCopo[wj][wk].x, 
		                	    (float)pontosNCopo[wj][wk].y, 
		                	    (float)pontosNCopo[wj][wk].z);
        	   }
           }

           gl.glEnd();
       }
       
       //--------------------------------------------------------------
       gl.glLineWidth(5);
       gl.glBegin(GL.GL_LINES);
       //Vetores tangentes - Ru
          gl.glColor3f(1.0f, 1.0f, 0.0f);
          gl.glVertex3f((float)pontosCopo[posCurva][posPonto].x,
              	        (float)pontosCopo[posCurva][posPonto].y,
                    	(float)pontosCopo[posCurva][posPonto].z);
          gl.glVertex3f((float)pontosUCopo[posCurva][posPonto].x, 
                	    (float)pontosUCopo[posCurva][posPonto].y, 
                	    (float)pontosUCopo[posCurva][posPonto].z);
      
      //Vetores tangentes - Rv
          gl.glColor3f(0.0f, 1.0f, 1.0f);
          gl.glVertex3f((float)pontosCopo[posCurva][posPonto].x, 
              	        (float)pontosCopo[posCurva][posPonto].y, 
                    	(float)pontosCopo[posCurva][posPonto].z);
          gl.glVertex3f((float)pontosVCopo[posCurva][posPonto].x, 
                	    (float)pontosVCopo[posCurva][posPonto].y, 
                	    (float)pontosVCopo[posCurva][posPonto].z);

      //Vetores normais - N
          gl.glColor3f(1.0f, 1.0f, 1.0f);
          gl.glVertex3f((float)pontosCopo[posCurva][posPonto].x, 
              	        (float)pontosCopo[posCurva][posPonto].y, 
                    	(float)pontosCopo[posCurva][posPonto].z);
          gl.glVertex3f((float)pontosNCopo[posCurva][posPonto].x, 
                	    (float)pontosNCopo[posCurva][posPonto].y, 
                	    (float)pontosNCopo[posCurva][posPonto].z);
       gl.glEnd();
       gl.glLineWidth(1);
       //--------------------------------------------------------------
       
       //Desenha os pontos de controle
       if (desenhaPontosControle) {
		   gl.glColor3f(1.0f, 0.0f, 0.0f);
		   gl.glBegin(GL.GL_POINTS);
		      gl.glVertex3f((float)pontosControle[0].x, (float)pontosControle[0].y, (float)pontosControle[0].z); 
		      gl.glVertex3f((float)pontosControle[1].x, (float)pontosControle[1].y, (float)pontosControle[1].z);
		      gl.glVertex3f((float)pontosControle[2].x, (float)pontosControle[2].y, (float)pontosControle[2].z);
		      gl.glVertex3f((float)pontosControle[3].x, (float)pontosControle[3].y, (float)pontosControle[3].z);
		   gl.glEnd();
		   gl.glBegin(GL.GL_LINES);
		      gl.glVertex3f((float)pontosControle[0].x, (float)pontosControle[0].y, (float)pontosControle[0].z); 
		      gl.glVertex3f((float)pontosControle[1].x, (float)pontosControle[1].y, (float)pontosControle[1].z);
		      
		      gl.glVertex3f((float)pontosControle[1].x, (float)pontosControle[1].y, (float)pontosControle[1].z); 
		      gl.glVertex3f((float)pontosControle[2].x, (float)pontosControle[2].y, (float)pontosControle[2].z);
		      
		      gl.glVertex3f((float)pontosControle[2].x, (float)pontosControle[2].y, (float)pontosControle[2].z);
		      gl.glVertex3f((float)pontosControle[3].x, (float)pontosControle[3].y, (float)pontosControle[3].z);
		   gl.glEnd();
       }
	   
   }
   
  
   
   public void displayChanged(GLAutoDrawable gLDrawable, boolean modeChanged, boolean deviceChanged) {
   }

   public void init(GLAutoDrawable gLDrawable) {
       final GL gl = gLDrawable.getGL();
       gl.glShadeModel(GL.GL_SMOOTH);
       gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
       gl.glClearDepth(1.0f);
       gl.glEnable(GL.GL_DEPTH_TEST);
       gl.glDepthFunc(GL.GL_LEQUAL);
       gl.glHint(GL.GL_PERSPECTIVE_CORRECTION_HINT, GL.GL_NICEST);
       gl.glPointSize(10.0f);
       gLDrawable.addKeyListener(this);
   }


public void reshape(GLAutoDrawable gLDrawable, int x, int y, int width, int height) {
       final GL gl = gLDrawable.getGL();
       if(height <= 0) {
           height = 1;
       }
       final float h = (float)width / (float)height;
       gl.glMatrixMode(GL.GL_PROJECTION);
       gl.glLoadIdentity();
       glu.gluPerspective(50.0f, h, 1.0, 1000.0);
       gl.glMatrixMode(GL.GL_MODELVIEW);
       gl.glLoadIdentity();
   }

   public void keyPressed(KeyEvent e) {
       if(e.getKeyCode() == KeyEvent.VK_ESCAPE) {
           Frenet.bQuit = true;
           Frenet.displayT.stop();
           System.exit(0);
       }
       
       if(e.getKeyCode() == KeyEvent.VK_UP) {
    	   if (posPonto < 40) {
    		   posPonto++;
    	   }
       }
       
       if(e.getKeyCode() == KeyEvent.VK_DOWN) {
    	   if (posPonto > 0) {
    		   posPonto--;
    	   }
       }
       
       if(e.getKeyCode() == KeyEvent.VK_LEFT) {
    	   if (posCurva < 35) {
    		   posCurva++;
    	   } else
   		   if (posCurva == 35) {
       		   posCurva = 0;
       	   }
       }
       
       if(e.getKeyCode() == KeyEvent.VK_RIGHT) {
    	   if (posCurva > 0) {
    		   posCurva--;
    	   } else
       	   if (posCurva == 0) {
           	   posCurva = 35;
           }
       }
       
       if(e.getKeyCode() == KeyEvent.VK_G) {
    	   curvatura = "g";
       }
       
       if(e.getKeyCode() == KeyEvent.VK_M) {
    	   curvatura = "m";
       }

       if(e.getKeyCode() == KeyEvent.VK_N) {
    	   curvatura = "n";
       }
       
       if(e.getKeyCode() == KeyEvent.VK_1) {
    	   desenhaPontosControle = !desenhaPontosControle; 
       }
       
       if(e.getKeyCode() == KeyEvent.VK_2) {
    	   desenhaCopo = !desenhaCopo; 
       }
       
       if(e.getKeyCode() == KeyEvent.VK_3) {
    	   desenhaPontosCurva = !desenhaPontosCurva; 
       }
       
       if(e.getKeyCode() == KeyEvent.VK_4) {
    	   desenhaVetorU = !desenhaVetorU; 
       }
       
       if(e.getKeyCode() == KeyEvent.VK_5) {
    	   desenhaVetorV = !desenhaVetorV; 
       }
       
       if(e.getKeyCode() == KeyEvent.VK_6) {
    	   desenhaVetorN = !desenhaVetorN; 
       }
   }

   public void keyReleased(KeyEvent e) {
   }

   public void keyTyped(KeyEvent e) {
   }
}
